// IMPORTANT NOTICE: 
// You should never modify classes in this file manully. 
// To attach additional functions to entity classes, you should write partial classes in separate files.

using System;
using NBear.Common;

namespace SimpleGuestbook.Entities
{
    [Serializable]
    public partial class Admin : Entity
    {
        protected static EntityConfiguration _AdminEntityConfiguration;

        public override EntityConfiguration GetEntityConfiguration()
        {
            if (_AdminEntityConfiguration == null) _AdminEntityConfiguration = MetaDataManager.GetEntityConfiguration("SimpleGuestbook.Entities.Admin");
            return _AdminEntityConfiguration;
        }

        protected int _ID;
        protected string _Password;

        public int ID
        {
            get { return _ID; }
        }
        public string Password
        {
            get { return _Password; }
            set { OnPropertyChanged("Password", _Password, value); _Password = value; }
        }

        #region Get & Set PropertyValues

        public override void ReloadQueries(bool includeLazyLoadQueries)
        {
        }

        public override object[] GetPropertyValues()
        {
            return new object[] { _ID, _Password };
        }

        public override void SetPropertyValues(System.Data.IDataReader reader)
        {
            if (!reader.IsDBNull(0)) _ID = reader.GetInt32(0);
            if (!reader.IsDBNull(1)) _Password = reader.GetString(1);
            ReloadQueries(false);
        }

        public override void SetPropertyValues(System.Data.DataRow row)
        {
            if (!row.IsNull(0)) _ID = (int)row[0];
            if (!row.IsNull(1)) _Password = (string)row[1];
            ReloadQueries(false);
        }

        #endregion

        #region QueryCode

        public abstract class _
        {
            private _() { }

            public static PropertyItem ID = new PropertyItem("ID");
            public static PropertyItem Password = new PropertyItem("Password");
        }

        #endregion
    }

    [Serializable]
    public partial class Message : Entity
    {
        protected static EntityConfiguration _MessageEntityConfiguration;

        public override EntityConfiguration GetEntityConfiguration()
        {
            if (_MessageEntityConfiguration == null) _MessageEntityConfiguration = MetaDataManager.GetEntityConfiguration("SimpleGuestbook.Entities.Message");
            return _MessageEntityConfiguration;
        }

        protected int _ID;
        protected string _AdminFeedback;
        protected DateTime? _AdminFeedbackTime;
        protected string _Content;
        protected string _Email;
        protected bool _IsPrivate;
        protected string _Nick;
        protected DateTime _PostTime;

        public int ID
        {
            get { return _ID; }
        }
        public string AdminFeedback
        {
            get { return _AdminFeedback; }
            set { OnPropertyChanged("AdminFeedback", _AdminFeedback, value); _AdminFeedback = value; }
        }
        public DateTime? AdminFeedbackTime
        {
            get { return _AdminFeedbackTime; }
            set { OnPropertyChanged("AdminFeedbackTime", _AdminFeedbackTime, value); _AdminFeedbackTime = value; }
        }
        public string Content
        {
            get { return _Content; }
            set { OnPropertyChanged("Content", _Content, value); _Content = value; }
        }
        public string Email
        {
            get { return _Email; }
            set { OnPropertyChanged("Email", _Email, value); _Email = value; }
        }
        public bool IsPrivate
        {
            get { return _IsPrivate; }
            set { OnPropertyChanged("IsPrivate", _IsPrivate, value); _IsPrivate = value; }
        }
        public string Nick
        {
            get { return _Nick; }
            set { OnPropertyChanged("Nick", _Nick, value); _Nick = value; }
        }
        public DateTime PostTime
        {
            get { return _PostTime; }
            set { OnPropertyChanged("PostTime", _PostTime, value); _PostTime = value; }
        }

        #region Get & Set PropertyValues

        public override void ReloadQueries(bool includeLazyLoadQueries)
        {
        }

        public override object[] GetPropertyValues()
        {
            return new object[] { _ID, _AdminFeedback, _AdminFeedbackTime, _Content, _Email, _IsPrivate, _Nick, _PostTime };
        }

        public override void SetPropertyValues(System.Data.IDataReader reader)
        {
            if (!reader.IsDBNull(0)) _ID = reader.GetInt32(0);
            if (!reader.IsDBNull(1)) _AdminFeedback = reader.GetString(1);
            if (!reader.IsDBNull(2)) _AdminFeedbackTime = (DateTime?)reader.GetValue(2);
            if (!reader.IsDBNull(3)) _Content = reader.GetString(3);
            if (!reader.IsDBNull(4)) _Email = reader.GetString(4);
            if (!reader.IsDBNull(5)) _IsPrivate = reader.GetBoolean(5);
            if (!reader.IsDBNull(6)) _Nick = reader.GetString(6);
            if (!reader.IsDBNull(7)) _PostTime = reader.GetDateTime(7);
            ReloadQueries(false);
        }

        public override void SetPropertyValues(System.Data.DataRow row)
        {
            if (!row.IsNull(0)) _ID = (int)row[0];
            if (!row.IsNull(1)) _AdminFeedback = (string)row[1];
            if (!row.IsNull(2)) _AdminFeedbackTime = (DateTime?)row[2];
            if (!row.IsNull(3)) _Content = (string)row[3];
            if (!row.IsNull(4)) _Email = (string)row[4];
            if (!row.IsNull(5)) _IsPrivate = (bool)row[5];
            if (!row.IsNull(6)) _Nick = (string)row[6];
            if (!row.IsNull(7)) _PostTime = (DateTime)row[7];
            ReloadQueries(false);
        }

        #endregion

        #region QueryCode

        public abstract class _
        {
            private _() { }

            public static PropertyItem ID = new PropertyItem("ID");
            public static PropertyItem AdminFeedback = new PropertyItem("AdminFeedback");
            public static PropertyItem AdminFeedbackTime = new PropertyItem("AdminFeedbackTime");
            public static PropertyItem Content = new PropertyItem("Content");
            public static PropertyItem Email = new PropertyItem("Email");
            public static PropertyItem IsPrivate = new PropertyItem("IsPrivate");
            public static PropertyItem Nick = new PropertyItem("Nick");
            public static PropertyItem PostTime = new PropertyItem("PostTime");
        }

        #endregion
    }

}
