using System;
using System.Collections.Generic;
using System.Text;

using NBear.Common;
using NBear.IoC.Service;
using SimpleGuestbook.Entities;

namespace SimpleGuestbook.ServiceInterfaces
{
    public interface IMessageService : IServiceInterface
    {
        Message[] GetMessages(int pageSize, int pageNo, bool includePrivate);
        int GetMessagePageCount(int pageSize, bool includePrivate);
        void AddMessage(Message msg);
        void UpdateAdminFeedback(int msgID, string feedbackContent);
        void DeleteMessage(int id);
    }

    public interface IAdminService : IServiceInterface
    {
        bool VerifyPassword(string password);
        void ResetPassword(string password);
    }
}
